package cn.com.qmth.stmms.biz.exam.bean;

import java.util.Date;
import java.util.List;

import cn.com.qmth.stmms.biz.exam.model.ExamSubject;
import cn.com.qmth.stmms.biz.mark.model.MarkConfigItem;
import cn.com.qmth.stmms.biz.mark.model.MarkStepDTO;
import cn.com.qmth.stmms.biz.mark.model.SpecialTagDTO;
import cn.com.qmth.stmms.biz.mark.model.Task;
import io.swagger.annotations.ApiModelProperty;

public class TaskVo {

    /**
     * 评卷任务编号
     */
    @ApiModelProperty(value = "评卷任务id")
    private Integer libraryId;

    /**
     * 考生编号
     */
    @ApiModelProperty(value = "考生id")
    private Integer studentId;

    /**
     * 显示考生密号
     */
    @ApiModelProperty(value = "密号")
    private String secretNumber;

    /**
     * 考生名称
     */
    @ApiModelProperty(value = "考生名称")
    private String studentName;

    /**
     * 学号
     */
    @ApiModelProperty(value = "学号")
    private String studentCode;

    /**
     * 准考证号
     */
    @ApiModelProperty(value = "准考证号")
    private String examNumber;

    /**
     * 科目
     */
    @ApiModelProperty(value = "科目信息")
    private ExamSubject subject;

    /**
     * 裁切图地址
     */
    @ApiModelProperty(value = "裁切图地址")
    private List<String> sliceUrls;

    /**
     * 题卡图片拼接配置
     */
    @ApiModelProperty(value = "题卡图片拼接配置")
    private List<MarkConfigItem> sliceConfig;

    /**
     * 多媒体地址
     */
    @ApiModelProperty(value = "多媒体地址")
    private String jsonUrl;

    /**
     * 给分步骤
     */
    @ApiModelProperty(value = "给分步骤")
    private List<MarkStepDTO> questionList;

    /**
     * 特殊标记列表
     */
    @ApiModelProperty(value = "特殊标记列表")
    private SpecialTagDTO[] specialTagList;

    /**
     * 组长特殊标记列表
     */
    @ApiModelProperty(value = "组长特殊标记列表")
    private SpecialTagDTO[] headerTagList;

    /**
     * 题卡原图地址
     */
    @ApiModelProperty(value = "题卡原图地址")
    private List<String> sheetUrls;

    /**
     * 客观题总分
     */
    @ApiModelProperty(value = "客观题总分")
    private Double objectiveScore;

    /**
     * 评分
     */
    @ApiModelProperty(value = "评分")
    private Double markerScore;

    /**
     * 评卷时间
     */
    @ApiModelProperty(value = "评卷时间")
    private Date markerTime;

    /**
     * 是否自评
     */
    @ApiModelProperty(value = "是否自评")
    private Boolean self;

    /**
     * 是否回评
     */
    @ApiModelProperty(value = "是否回评")
    private Boolean previous;

    /**
     * 是否打回
     */
    @ApiModelProperty(value = "是否打回")
    private Boolean rejected;

    /**
     * 打回原因
     */
    @ApiModelProperty(value = "打回原因")
    private String rejectReason;

    /**
     * 打回上次分数
     */
    @ApiModelProperty(value = "打回上次分数")
    private String rejectScoreList;

    /**
     * 打回后的分数
     */
    @ApiModelProperty(value = "打回后的分数")
    private String afterRejectScoreList;

    /**
     * 评卷员登录名
     */
    @ApiModelProperty(value = "评卷员登录名")
    private String markerName;

    /**
     * 复核时间
     */
    @ApiModelProperty(value = "复核时间")
    private Date inspectTime;

    /**
     * 错误信息
     */
    @ApiModelProperty(value = "错误信息")
    private String message;

    /**
     * 仲裁题目位置
     */
    @ApiModelProperty(value = "仲裁题目位置")
    private String arbitrateIndex;

    @ApiModelProperty(value = "")
    private String collationLabelCode;

    @ApiModelProperty(value = "")
    private Boolean selectiveError;

    public Integer getLibraryId() {
        return libraryId;
    }

    public void setLibraryId(Integer libraryId) {
        this.libraryId = libraryId;
    }

    public Integer getStudentId() {
        return studentId;
    }

    public void setStudentId(Integer studentId) {
        this.studentId = studentId;
    }

    public String getSecretNumber() {
        return secretNumber;
    }

    public void setSecretNumber(String secretNumber) {
        this.secretNumber = secretNumber;
    }

    public String getStudentName() {
        return studentName;
    }

    public void setStudentName(String studentName) {
        this.studentName = studentName;
    }

    public String getStudentCode() {
        return studentCode;
    }

    public void setStudentCode(String studentCode) {
        this.studentCode = studentCode;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public ExamSubject getSubject() {
        return subject;
    }

    public void setSubject(ExamSubject subject) {
        this.subject = subject;
    }

    public List<String> getSliceUrls() {
        return sliceUrls;
    }

    public void setSliceUrls(List<String> sliceUrls) {
        this.sliceUrls = sliceUrls;
    }

    public List<MarkConfigItem> getSliceConfig() {
        return sliceConfig;
    }

    public void setSliceConfig(List<MarkConfigItem> sliceConfig) {
        this.sliceConfig = sliceConfig;
    }

    public String getJsonUrl() {
        return jsonUrl;
    }

    public void setJsonUrl(String jsonUrl) {
        this.jsonUrl = jsonUrl;
    }

    public List<MarkStepDTO> getQuestionList() {
        return questionList;
    }

    public void setQuestionList(List<MarkStepDTO> questionList) {
        this.questionList = questionList;
    }

    public SpecialTagDTO[] getSpecialTagList() {
        return specialTagList;
    }

    public void setSpecialTagList(SpecialTagDTO[] specialTagList) {
        this.specialTagList = specialTagList;
    }

    public SpecialTagDTO[] getHeaderTagList() {
        return headerTagList;
    }

    public void setHeaderTagList(SpecialTagDTO[] headerTagList) {
        this.headerTagList = headerTagList;
    }

    public List<String> getSheetUrls() {
        return sheetUrls;
    }

    public void setSheetUrls(List<String> sheetUrls) {
        this.sheetUrls = sheetUrls;
    }

    public Double getObjectiveScore() {
        return objectiveScore;
    }

    public void setObjectiveScore(Double objectiveScore) {
        this.objectiveScore = objectiveScore;
    }

    public Double getMarkerScore() {
        return markerScore;
    }

    public void setMarkerScore(Double markerScore) {
        this.markerScore = markerScore;
    }

    public Date getMarkerTime() {
        return markerTime;
    }

    public void setMarkerTime(Date markerTime) {
        this.markerTime = markerTime;
    }

    public Boolean getSelf() {
        return self;
    }

    public void setSelf(Boolean self) {
        this.self = self;
    }

    public Boolean getPrevious() {
        return previous;
    }

    public void setPrevious(Boolean previous) {
        this.previous = previous;
    }

    public Boolean getRejected() {
        return rejected;
    }

    public void setRejected(Boolean rejected) {
        this.rejected = rejected;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public String getRejectScoreList() {
        return rejectScoreList;
    }

    public void setRejectScoreList(String rejectScoreList) {
        this.rejectScoreList = rejectScoreList;
    }

    public String getAfterRejectScoreList() {
        return afterRejectScoreList;
    }

    public void setAfterRejectScoreList(String afterRejectScoreList) {
        this.afterRejectScoreList = afterRejectScoreList;
    }

    public String getMarkerName() {
        return markerName;
    }

    public void setMarkerName(String markerName) {
        this.markerName = markerName;
    }

    public Date getInspectTime() {
        return inspectTime;
    }

    public void setInspectTime(Date inspectTime) {
        this.inspectTime = inspectTime;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getArbitrateIndex() {
        return arbitrateIndex;
    }

    public void setArbitrateIndex(String arbitrateIndex) {
        this.arbitrateIndex = arbitrateIndex;
    }

    public String getCollationLabelCode() {
        return collationLabelCode;
    }

    public void setCollationLabelCode(String collationLabelCode) {
        this.collationLabelCode = collationLabelCode;
    }

    public Boolean getSelectiveError() {
        return selectiveError;
    }

    public void setSelectiveError(Boolean selectiveError) {
        this.selectiveError = selectiveError;
    }

    public static TaskVo of(Task from) {
        if (from == null) {
            return null;
        }
        TaskVo ret = new TaskVo();
        ret.setLibraryId(from.getLibraryId());
        ret.setStudentId(from.getStudentId());
        ret.setSecretNumber(from.getSecretNumber());
        ret.setStudentName(from.getStudentName());
        ret.setStudentCode(from.getStudentCode());
        ret.setExamNumber(from.getExamNumber());
        ret.setSubject(from.getSubject());
        ret.setSliceUrls(from.getSliceUrls());
        ret.setSliceConfig(from.getSliceConfig());
        ret.setJsonUrl(from.getJsonUrl());
        ret.setQuestionList(from.getQuestionList());
        ret.setSpecialTagList(from.getSpecialTagList());
        ret.setHeaderTagList(from.getHeaderTagList());
        ret.setSheetUrls(from.getSheetUrls());
        ret.setObjectiveScore(from.getObjectiveScore());
        ret.setMarkerScore(from.getMarkerScore());
        ret.setMarkerTime(from.getMarkerTime());
        ret.setSelf(from.isSelf());
        ret.setPrevious(from.isPrevious());
        ret.setRejected(from.isRejected());
        ret.setRejectReason(from.getRejectReason());
        ret.setRejectScoreList(from.getRejectScoreList());
        ret.setAfterRejectScoreList(from.getAfterRejectScoreList());
        ret.setMarkerName(from.getMarkerName());
        ret.setInspectTime(from.getInspectTime());
        ret.setMessage(from.getMessage());
        ret.setArbitrateIndex(from.getArbitrateIndex());
        ret.setCollationLabelCode(from.getCollationLabelCode());
        ret.setSelectiveError(from.getSelectiveError());
        return ret;
    }
}
