package cn.com.qmth.stmms.admin.dto;

import cn.com.qmth.stmms.biz.exam.model.OperationLog;
import cn.com.qmth.stmms.common.annotation.ExcelField;
import cn.com.qmth.stmms.common.utils.DateUtils;

public class OperationLogDTO {
    @ExcelField(title = "登录名", align = 2, sort = 10)
    private String loginName;

    @ExcelField(title = "用户类型", align = 2, sort = 20)
    private String userType;

    @ExcelField(title = "类型", align = 2, sort = 30)
    private String type;

    @ExcelField(title = "登录ip", align = 2, sort = 40)
    private String ip;

    @ExcelField(title = "功能", align = 2, sort = 50)
    private String menu;


    @ExcelField(title = "操作时间", align = 2, sort = 60)
    private String time;

    public OperationLogDTO(OperationLog log){
        this.ip = log.getIpAddress();
        this.menu = log.getMenu();
        this.time = DateUtils.formatDateTime(log.getCreateTime());
        this.type = log.getType().getName();
        this.loginName = log.getLoginName();
        this.userType =log.isMarker()?"评卷员":"管理员";
    }


    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getUserType() {
        return userType;
    }

    public void setUserType(String userType) {
        this.userType = userType;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getMenu() {
        return menu;
    }

    public void setMenu(String menu) {
        this.menu = menu;
    }

    public String getTime() {
        return time;
    }

    public void setTime(String time) {
        this.time = time;
    }
}
